(function( $ ){
  $.fn.grimcap = function( options ) {  

        var settings = {
            'displaytext'   : 'Drag the <em>OBJECT</em> to the circle!',
            'verifycode'    : 'grimrawks!',
            'imagelocation' : '/style/images/',
            'maximages'     : 6
        };

        return this.each(function() {        
        if ( options ) { 
            $.extend( settings, options );
        }
        var thecode = '<div class="outergrimcap"><div class="circlegrimcap"></div><div class="textgrimcap">'+settings['displaytext']+'</div><ul class="objectsgrimcap">' +
        
        '<li class="objectgrimcap" id="gc_aeroplane"><img src="'+settings['imagelocation']+'aeroplane.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_apple"><img src="'+settings['imagelocation']+'apple.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_arrows"><img src="'+settings['imagelocation']+'arrows.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_baby"><img src="'+settings['imagelocation']+'baby.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_basket"><img src="'+settings['imagelocation']+'basket.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_bike"><img src="'+settings['imagelocation']+'bike.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_bomb"><img src="'+settings['imagelocation']+'bomb.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_book"><img src="'+settings['imagelocation']+'book.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_brush"><img src="'+settings['imagelocation']+'brush.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_burger"><img src="'+settings['imagelocation']+'burger.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_camera"><img src="'+settings['imagelocation']+'camera.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_car"><img src="'+settings['imagelocation']+'car.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_clock"><img src="'+settings['imagelocation']+'clock.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_coffee"><img src="'+settings['imagelocation']+'coffee.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_computer"><img src="'+settings['imagelocation']+'computer.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_dice"><img src="'+settings['imagelocation']+'dice.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_Dollar"><img src="'+settings['imagelocation']+'Dollar.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_elephant"><img src="'+settings['imagelocation']+'elephant.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_fire"><img src="'+settings['imagelocation']+'fire.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_flag"><img src="'+settings['imagelocation']+'flag.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_guitar"><img src="'+settings['imagelocation']+'guitar.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_heart"><img src="'+settings['imagelocation']+'heart.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_house"><img src="'+settings['imagelocation']+'house.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_joypad"><img src="'+settings['imagelocation']+'joypad.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_key"><img src="'+settings['imagelocation']+'key.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_ladybird"><img src="'+settings['imagelocation']+'ladybird.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_piggy-bank"><img src="'+settings['imagelocation']+'piggy-bank.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_rocket"><img src="'+settings['imagelocation']+'rocket.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_strawberry"><img src="'+settings['imagelocation']+'strawberry.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_tortoise"><img src="'+settings['imagelocation']+'tortoise.png" alt="Object" /></li>' +
        '<li class="objectgrimcap" id="gc_trophy"><img src="'+settings['imagelocation']+'trophy.png" alt="Object" /></li>' +

        '</ul><div style="clear: both"></div></div><input type="hidden" name="grimcapverify" id="grimcapverify" />';
      
        $(this).html(thecode);
      
        //randomise the items
        var $li = $(".objectgrimcap").hide();
        var len = $li.length;
        var counter = 0;
        var max = settings['maximages'];
        var randomnumber;
        while (max > counter) {
            randomnumber = Math.floor(Math.random() * (len + 1));
            if ($li.eq(randomnumber).is(":hidden")) {
                $li.eq(randomnumber).show();
                counter ++;
            }            
        }
        //get rid of the ones not shown
        $(".objectgrimcap").each(function() {
             if ($(this).is(":hidden")) {
                $(this).remove();   
             }
        });
        
        $(".objectgrimcap").draggable({
            containment   : ".outergrimcap"
        });

        $li = $(".objectgrimcap")
        len = $li.length;
        randomnumber = Math.floor(Math.random() * len);
        var chosen = $li.eq(randomnumber).attr("id");
        
        $(".textgrimcap em").text(chosen.substr(3));
        
        $(".circlegrimcap").droppable({
            accept  : '.objectgrimcap',
            drop    : function(event, ui) {
                var thisid = ui.draggable.attr("id");
                $("#"+thisid+" img").animate({
                    height: '1px',
                    width: '1px',
                    'margin-top': '14px',
                    'margin-left': '14px'
                }, 250, function() {
                    $("#"+thisid+" img").remove();
                    $(".circlegrimcap").html('<img src="'+settings['imagelocation']+thisid.substr(3)+'.png" style="margin: 49px 0px 0px 49px; width: 1px; height: 1px" />');
                    $(".circlegrimcap img").animate({
                        height: '48px',
                        width: '48px',
                        'margin-top': '26px',
                        'margin-left': '27px'
                    }, 250);
                });    
                $(".objectgrimcap").draggable("disable");
                $(".objectgrimcap").fadeTo(500, 0.33);
                if (thisid == chosen) {
                    $("#grimcapverify").val(settings['verifycode']);
                }
            }
        });
    });
  };
})( jQuery );